#pragma once
#include <string>
#include <iostream>
#include <sstream>
#include <cstdlib>
#include <vector>
#include <map>
#include "SGString.h"

class value;
class PGValue;
	typedef std::vector<PGValue> PGJArray;
	typedef std::vector<PGValue>::const_iterator PGJAIterator;
	typedef std::vector<PGValue>::iterator PGJANIterator;
	typedef std::map<SGString,PGValue> PGJObject;         ///< @brief ֥ȷ
	typedef std::map<SGString,PGValue>::const_iterator PGJOIterator; ///< @brief @ref JObject Υƥ졼
	typedef std::map<SGString,PGValue>::iterator PGJONIterator; ///< @brief @ref JObject Υƥ졼
class PGValue
{

  public:

	PGValue();
	PGValue( const char* a );
	PGValue( const std::string& a );
	PGValue( int a );
	PGValue( bool a );
	PGValue( const PGJObject& a );
	PGValue( const PGJArray& a );
	PGValue( const value& a );

	PGValue& operator=( const char* a );
	PGValue& operator=( const std::string& a );
	PGValue& operator=( int a );
	PGValue& operator=( bool a );
	PGValue& operator=( const PGJObject& a );
	PGValue& operator=( const PGJArray& a );

	bool operator==( const PGValue& a ); // const
	bool operator==( const char* a ); // const
	bool operator==( const std::string& a ); // const
	bool operator==( int a ); // const
	bool operator==( bool a ); // const
	bool operator==( const PGJObject& a ); // const
	bool operator==( const PGJArray& a ); // const

	bool operator!=( const PGValue& a ); // const
	bool operator!=( const char* a ); // const
	bool operator!=( const std::string& a ); // const
	bool operator!=( int a ); // const
	bool operator!=( bool a ); // const
	bool operator!=( const PGJObject& a ); // const
	bool operator!=( const PGJArray& a ); // const

	operator const char*() const;
	friend std::ostream& operator<<( std::ostream& os,  PGValue& val ); // const

	PGValue& Set( const char* a );
	PGValue& Set( const std::string& a );
	PGValue& Set( int a );
	PGValue& Set( bool a );
	PGValue& Set( const PGJObject& a );
	PGValue& Set( const PGJArray& a );

	int GetType() const;
	int GetInt() const;
	const char* GetChar() const;
	bool GetBool() const;
	const std::string& GetString();// const;
	const PGJObject GetObject() const;
	const PGJArray GetArray() const;

protected:
	typedef enum{
		TYPE_NONE,
		TYPE_INT,
		TYPE_STRING,
		TYPE_BOOL,
		TYPE_OBJECT,
		TYPE_ARRAY,
	} Type_t;


	Type_t mType;
	int mInt;
	std::string mString;
	PGJObject* mObject;
	PGJArray* mArray;
};
