#pragma once
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <string>
#include <vector>

using namespace std;  // ★←いつか消す

// typedef const char* LPTSTR;

class SGStringArray;

//-----------------------------------------------------------------------------
/**
@brief 文字列クラス
*/
class SGString : public std::string
{
public:
	SGString();
	SGString(const char* str);
	SGString(std::string str);
	virtual ~SGString();

	void Clear();
	SGString *Format(const char *f, ...);

	void Separate(char sep,SGStringArray& array);
	void Trim(char* str);
	int GetLength() const;
	int GetCharLength() const;
	SGString GetChar(int st,int len=-1);
	operator const char*() const;
	bool operator==(const char* str);
	bool operator==(const SGString& str);
	SGString& operator=(const char* str);
	SGString& operator=(std::string str);
	SGString& operator=(SGString str);

	int ToInt();
	double ToDouble();

	SGString GetFileExtension();
	SGString GetFileNameWithoutExtension();
	SGString MakeUpper();

	SGString Replace(SGString strold, SGString strnew);
private:
	int GetUTF8Code( const unsigned char* text,int nn,unsigned int* code) const;
};

//-----------------------------------------------------------------------------
/**
@brief 文字列の集合クラス
*/
class SGStringArray : public std::vector<SGString>
{
public:
	SGStringArray();
	virtual ~SGStringArray();

	void Empty();
	int IsEmpty();
	int Size();
	SGString& operator [](int n);
	SGStringArray& operator +=(const SGString& str);
	int Find(SGString& str);

private:
	SGString mZero; ///< @brief ゼロ
};
